<template>
  <crud-data-table-delete
    v-model="dialog"
    :entity-being-deleted="$t('paymentStatus')"
    :item-being-deleted="paymentStatusBeingDeleted"
    :loading="isLoading"
    @onAgree="onAgree"
    @onDisagree="onDisagree"
  />
</template>

<script>
  export default {
    name: 'DeletePaymentMethodDialog',
    data () {
      return {
        dialog: false,
        isLoading: false,
        paymentStatusBeingDeleted: {},
      }
    },
    created () {
      this.$emit('onDeletePaymentStatus', this.onDeletePaymentStatus)
    },
    methods: {
      onDeletePaymentStatus (paymentStatus) {
        this.paymentStatusBeingDeleted = paymentStatus
        this.dialog = true
      },
      onAgree () {
        this.isLoading = true
        this.$store.dispatch('paymentStatuses/deletePaymentStatus', {
          ID: this.paymentStatusBeingDeleted.id,
        })
          .then(() => {
            this.$store.dispatch('toast/setOptions', {
              variant: 'success',
              text: this.$t('deleteSuccess'),
            })
          })
          .catch(() => {
            this.$store.dispatch('toast/setOptions', {
              variant: 'error',
              text: this.$t('deleteError'),
            })
          })
          .finally(() => {
            this.dialog = false
            this.isLoading = false
          })
      },
      onDisagree () {
        this.dialog = false
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          paymentStatus: 'Status',
          deleteSuccess: 'Status excluído com sucesso!',
          deleteError: 'Ops... Algo deu errado ao tentar excluir o status. Por favor, tente novamente.',
        },
        'en-US': {
          paymentStatus: 'Payment status',
          deleteSuccess: 'Payment status successfully deleted!',
          deleteError: 'Oops... Something went wrong while trying to delete the payment status. Please try again.',
        },
      },
    },
  }
</script>
